/*-
 * Copyright 2021 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.ade.foodwaterenergycitygml4j.landuse.model;


import java.util.ArrayList;
import java.util.List;

import org.citygml4j.builder.copy.CopyBuilder;
import org.citygml4j.model.citygml.ade.binding.ADEModelObject;
import org.citygml4j.model.common.visitor.FeatureFunctor;
import org.citygml4j.model.common.visitor.FeatureVisitor;
import org.citygml4j.model.common.visitor.GMLFunctor;
import org.citygml4j.model.common.visitor.GMLVisitor;
import org.citygml4j.model.gml.feature.AbstractFeature;



public class ConsistsOfFWESurvey extends AbstractFeature implements ADEModelObject{
	
	private static final long serialVersionUID = 5976037320544049731L;
	
	private List<LandUseSurvey> landUseSurvey;
	
	public List<LandUseSurvey> getLandUseSurvey() {
		if(landUseSurvey == null) {
			landUseSurvey = new ArrayList<>();
		}
		return landUseSurvey;
	}
	
	public boolean isLandUseSurvey() {
		return landUseSurvey != null;
	}
	public void setLandUseSurvey(List<LandUseSurvey> landUseSurvey) {
		this.landUseSurvey = landUseSurvey;
	}

	@Override
	public Object copy(CopyBuilder copyBuilder) {
		return copyTo(new ConsistsOfFWESurvey(),copyBuilder);
	}

	@Override
	public void accept(FeatureVisitor visitor) {
		visitor.visit((ADEModelObject)this);
	}

	@Override
	public <T> T accept(FeatureFunctor<T> visitor) {
		return visitor.apply((ADEModelObject)this);
	}

	@Override
	public void accept(GMLVisitor visitor) {
		visitor.visit((ADEModelObject)this);
		
	}

	@Override
	public <T> T accept(GMLFunctor<T> visitor) {
		return visitor.apply((ADEModelObject)this);
	}	

	
}
